jQuery(document).ready(function($){
    var Quiz = function(){
      var self = this;
      this.init = function(){
        self._bindEvents();
      }
      
      this.correctAnswers = [
        { question: 1, answer: 'b'},
        { question: 2, answer: 'd'},
        { question: 3, answer: 'c' },
        { question: 4, answer: 'd' },
        { question: 5, answer: 'c' },
        { question: 6, answer: 'a' },
        { question: 7, answer: 'c' },
        { question: 8, answer: 'c' },
        { question: 9, answer: 'c' },
        { question: 10, answer: 'b' },
        { question: 11, answer: 'a' },
      ]
      
      this._pickAnswer = function($answer, $answers){
        $answers.find('.quiz-answer').removeClass('active');
        $answer.addClass('active');
      }
      var numberOfCorrectAnswers = 0;
      this._calcResult = function(){
        
        $('ul[data-quiz-question]').each(function(i){
          var $this = $(this),
              chosenAnswer = $this.find('.quiz-answer.active').data('quiz-answer'),
              correctAnswer;
          
          for ( var j = 0; j < self.correctAnswers.length; j++ ) {
            var a = self.correctAnswers[j];
            if ( a.question == $this.data('quiz-question') ) {
              correctAnswer = a.answer;
            }
          }
          
          if ( chosenAnswer == correctAnswer ) {
            numberOfCorrectAnswers++;
            
            // highlight this as correct answer
            $this.find('.quiz-answer.active').addClass('correct');
          }
          else {
            $this.find('.quiz-answer[data-quiz-answer="'+correctAnswer+'"]').addClass('correct');
            $this.find('.quiz-answer.active').addClass('incorrect');
          }
        });
        if ( numberOfCorrectAnswers < 6 ) {
          return {code: 'bad', text: 'Unfortunately, you answered correctly less than half of the questions. Improve your online gambling skills. Play and win at the top 5 casinos. '};
        }
        else if ( numberOfCorrectAnswers > 5 && numberOfCorrectAnswers < 11 ) {
          return {code: 'mid', text: 'Congratulations! You have answered more than half of the questions correctly. To improve your knowledge in the field of online gambling, we suggest you practice some more with the top casinos for newbies.'};
        }
        else if ( numberOfCorrectAnswers > 10 ) {
          return {code: 'good', text: 'Congratulations! You are an expert in online gambling. We have made a list of the most interesting casinos especially for you.'};
        }
      }
      this._isComplete = function(){
        var answersComplete = 0;
        $('ul[data-quiz-question]').each(function(){
          if ( $(this).find('.quiz-answer.active').length ) {
            answersComplete++;
          }
        });
        if ( answersComplete >= 11 ) {
          return true;
        }
        else {
          return false;
        }
      }
      this._showResult = function(result){
        $('.quiz-result').addClass(result.code);
        $('.quiz-result-count').html('You scored: ' + numberOfCorrectAnswers + '/10');
        $('.quiz-result-text').html(result.text);
        $('.quiz-answer-result').show();

     	  
      }
      this._bindEvents = function(){
        $('.quiz-answer').on('click', function(){
          var $this = $(this),
              $answers = $this.closest('ul[data-quiz-question]');
          self._pickAnswer($this, $answers);
          if ( self._isComplete() ) {
            
            // scroll to answer section
            $('html, body').animate({
              scrollTop: $('.quiz-result').offset().top
            });
            
            self._showResult( self._calcResult() );
            $('.quiz-answer').off('click');
            
          }
        });
      }
    }
    var quiz = new Quiz();
    quiz.init();
});